// moneyLib.cpp
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "moneyLib.h"

String money::doub2str(double amount)
{
	float fraction;
	long whole=0, twodigits=0;
	char tmp[80],tmp1[80],tmp2[80],tmp3[80];
	int len=0,cnt=0,i=0,j=0;
	short negative=0;
	
	if (amount < 0)
	{
		negative = 1;
		amount *= -1;
	}
	whole = amount;
	fraction = amount - whole;
	twodigits = (int) (fraction * 100);
	sprintf(tmp1,".%02d",twodigits);
	sprintf(tmp2,"%d",whole);
	
	// add commas
	cnt=0;
	len = strlen(tmp2);
	if (!(len%3))
		cnt = len + (len/3) - 1;
	else
		cnt = len + (len/3);
	
	cnt++;  // for sign symbol
			
	tmp3[cnt] = '\0';
	cnt--; len--;
	for (i=len,j=0; i >= 0; i--,cnt--,j++)
	{
		if (j && !(j%3))
		{
			tmp3[cnt] = ',';
			cnt--;
		}
		
		tmp3[cnt] = tmp2[i];
	}
	
	if (negative)
		tmp3[0] = '-';
	else
		tmp3[0] = '+';

	sprintf(tmp,"%s%s",tmp3,tmp1);	
	return String(tmp);
}

money::money()
{
	display = "0.00";
	value = 0;
}

money::~money() { }

money::money(double amount)
{
	display = doub2str(amount);
	value = amount;
}

money &money::operator = (double amount)
{
	value = amount;
	display = doub2str(amount);	
	return *this;
}

money &money::operator = (money &other)
{
	if (this == &other)
		return *this;
	value = other.value;
	display = other.display;
 	return *this;
}

money money::operator + (money &right)
{
	money temp;
	temp.value = value + right.value;
	temp.display = doub2str(temp.value);
	return temp;
}

ostream &operator << (ostream &stream, money &other)
{
	stream << other.display;
	return stream;
}

int money::Strlen()
{
	return display.getlen();
}

money::operator double()
{
	return value;
}

money::operator String()
{
	return display;
}
