// strarray.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>

int match_word(char list[][5], int list_len, char *word)
{
	int i;
	cout << "As a 2d array of char, start of list is " << (void *) list << endl;
	for (i=0; i < list_len; i++)
	{
		cout << "list[" << i << "] holds " << (void *) list[i]
		     << " and points to " << list[i] << endl;
		cout << "list[" << i << "] is offset " << (long)&(list[i]) - (long)list 
			 << " bytes." << endl;
		if (!(strcmp(list[i], word)))
			return(i);
	}
	return(-1);
}

// overload match_word to handle both cases
int match_word(char *list[], int list_len, char *word)
{
	int i;
	cout << "As a Pointer Array, start of list is " << (void *) list << endl;
	for (i=0; i < list_len; i++)
	{
		cout << "list[" << i << "] holds " << (void *) list[i]
		     << " and points to " << list[i] << endl;
		cout << "list[" << i << "] is offset " << (long)&(list[i]) - (long)list
			 << " bytes." << endl;
		if (!(strcmp(list[i], word)))
			return(i);
	}
	return(-1);
}

void main()
{
	int index=0;
	char days[][5] = { "BAD", "mon", "tue", "wed", "thu", "fri", "sat", "sun" };
	
	// a more efficient method of storage
	char *months[] = { "illegal Value", "January", "February", "March", "April",
					   "May", "June", "July", "August", "September", 
					   "October", "November", "December" };
	
	char *verbs[] = { "run", "go", "get", "throw", "hit", "punch", "look",
	                "walk", "eat", "jump", "climb", "duck", "sleep"};

	index = match_word(days,8, "wed");
	cout << "RETURNS:index in days is " << index << endl;

	index = match_word(months,13, "February");
	cout << "RETURNS:index in months is " << index << endl;		
}
