// structst.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <ctype.h>

struct employee {
	char name[80];
	int age;
	char address[256];
};

void func1(struct employee *employee_ptr)
{
	strcpy(employee_ptr->name,"harry houdini");
}

void func2(struct employee employee_copy)
{
	strcpy(employee_copy.name,"Theodore Roosevelt");
	cout << "my employee has a new name " << employee_copy.name << endl;
}

void func3(struct employee& employee_ref)
{
	strcpy(employee_ref.name,"Pat Conroy");
}

void main()
{
	struct employee joe = {"joe blow",32,"222 main street, nowhere, US"};
	
	struct employee *eptr;
	
	cout << "the starting address of joe is " << &joe << endl;
	eptr = &joe;
	cout << "eptr holds " << eptr << endl;
	cout << "the full name of joe is " << joe.name << endl;
	cout << "the full name of joe is " << eptr->name << endl;
	cout << "the full name of joe is " << (*eptr).name << endl;
	
	// we can copy the address of the joe structure to the stack,
	//   for func1 
	func1(&joe);
	
	// func1 changed the name of our employee
	cout << "the full name of joe is now " << joe.name << endl;
	cout << "the full name of joe is now " << eptr->name << endl;
	
	// we can copy the entire structure to the stack for func2
	func2(joe);

	// func2 DID NOT CHANGE the name of our employee
	cout << "the full name of joe is still " << joe.name << endl;
	cout << "the full name of joe is still " << eptr->name << endl;	

	// we can take a reference to the structure
	func3(joe);
	
	// func3 changed the name of our employee
	cout << "the full name of joe is now " << joe.name << endl;
	cout << "the full name of joe is now " << eptr->name << endl;
}
