// this.cpp
#include <iostream.h>
#include <iomanip.h>

class foo {
		int X,Y;
	public:
		foo();
		foo(int a, int b);
		foo *foo_this();
		~foo();
		friend ostream &operator << (ostream &stream, foo &inobj);
};

foo::foo()
{
	X=Y=0;
}

foo::foo(int a, int b)
{
	cout << "this is " << this << endl;
	this->X = a;
	this->Y = b;
}

foo::~foo()
{
	X=Y=0;
}

foo *foo::foo_this()
{
	return this;
}

ostream &operator << (ostream &stream, foo &inobj)
{
	// NO THIS passed in.
	cout << "X is " << inobj.X << endl;
	cout << "Y is " << inobj.Y << endl;
	return stream;
}

void main()
{
	foo bar(2,10);
	foo *foop=0;
	cout << bar;
	foop = bar.foo_this();
	cout << "foop is " << foop << endl;
	cout << "foop->X is " << *((int *)foop) << endl;
	cout << "foop->Y is " << *((int *)foop+1) << endl;
	// NOTE:
	//       foop->X is ILLEGAL
	//       foop->Y is ILLEGAL
	//       ******* this is for demo only *******
}

