// error.h - an error message class

struct AppErrors {
	char *msg;
	int severity;
};

class error {
	protected:
		static AppErrors StdErrors[];
		static int numErrors;
		int stdidx;
		char File[80];
		int Line;
	public:
		error();
		void StandardError(int index, char *thefile="UNKNOWN", int theline=0,
						   ostream &stream=cerr);		
		void CustomError(char *msg,int level,
						 char *thefile="UNKNOWN", int theline=0, ostream &stream=cerr);
};

// #defines for standard errors
#define NOMEM 0
#define NULLARG 1
#define ILLINP 2
#define NOTOPEN 3
#define NOREWIND 4
