#include <iostream.h>

class Base {
	protected:
		int A;
	public:
		Base();
		~Base();
		virtual void set(void) = 0;
		virtual void print(void) = 0;
};

Base::Base()
{
	cout << "Calling Base Constructor." << endl;
	A=0;
}

Base::~Base()
{
	cout << "Calling Base Destructor." << endl;
	A=0;
}

class Deriv1 : public Base {
		int B;
	public:
		Deriv1();
		~Deriv1();
		void set(void);
		void print(void);
};

Deriv1::Deriv1()
{
	cout << "Calling Deriv1 Constructor." << endl;
	B = 0;
}

Deriv1::~Deriv1()
{
	cout << "Calling Deriv1 Destructor." << endl;
	B = 0;
}

void Deriv1::set(void)
{
	cout << " A : ";
	cin >> A;
	cout << " B : ";
	cin >> B;
}

void Deriv1::print(void)
{
	cout << " A : " << A << endl;
	cout << " B : " << B << endl;
}

class Deriv2 : public Base {
		int C;
	public:
		Deriv2();
		~Deriv2();
		void set(void);
		void print(void);
};

Deriv2::Deriv2()
{
	cout << "Calling Deriv2 Constructor." << endl;
	C = 0;
}

Deriv2::~Deriv2()
{
	cout << "Calling Deriv2 Destructor." << endl;
	C = 0;
}

void Deriv2::set(void)
{
	cout << " A : ";
	cin >> A;
	cout << " C : ";
	cin >> C;
}

void Deriv2::print(void)
{
	cout << " A : " << A << endl;
	cout << " C : " << C << endl;
}

int main()
{
	Deriv1 ob1;
	Deriv2 ob2;
	Base *bp1, *bp2;
	bp1 = &ob1;
	bp2 = &ob2;
	cout << "Base Pointer->Deriv1 Object." << endl;
	bp1->set();
	bp1->print();
	cout << endl;

	cout << "Base Pointer->Deriv2 Object." << endl;
	bp2->set();
	bp2->print();
	return 0;
}
	
