// propref.cpp
#include <iostream.h>
#include <iomanip.h>

void main()
{
	int myint=5;
	int& intref=myint;  // MUST initialize a reference
/*	int& refarray[10];  ****** ILLEGAL  ***** You cannot create a group of NOTHING */
	int *intptr;
	
	intref = myint;
	cout << "address of myint is " << &myint << endl;
	cout << "address of intref is " << &intref << endl;
	
/*	intptr = intref;  ** ILLEGAL ** do not confuse a reference with "address-of"
                                    a reference is not an address although it
                                    seems that way when we use them for 
                                    "passing by reference".  Here the reference
                                    is just another name for the int "myint".
                                    We know that you cannot assign an integer
                                    to a pointer to an integer. */
	cout << "myint holds " << myint << endl;
	intptr = &intref;
	intref++;
	cout << "now myint holds " << myint << endl;
}
