// multiuse.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>

struct inventory {
	char type; // f-furniture, c-clothes, e-equipment...
	char name[80];
	
	union {
		struct {
			char room[80];
			float price;
		} furniture;
		
		struct {
			char person[80];
			char closet[80];
		} clothes;
		
		struct {
			char brand[80];
			char purpose[80];
			char serialno[80];
		} equipment;
	} item;
};

void main()
{
	inventory objects[3];
	int i=0;
	
	objects[0].type = 'f';
	strcpy(objects[0].name, "couch");
	strcpy(objects[0].item.furniture.room, "living room");
	objects[0].item.furniture.price = 1235.99;
	
	objects[1].type = 'c';
	strcpy(objects[1].name, "blouse");
	strcpy(objects[1].item.clothes.person,"lynne");
	strcpy(objects[1].item.clothes.closet,"Master Bedroom");
	
	objects[2].type = 'e';
	strcpy(objects[2].name, "cassete player");
	strcpy(objects[2].item.equipment.brand,"Kenwood");
	strcpy(objects[2].item.equipment.purpose,"entertainment");
	strcpy(objects[2].item.equipment.serialno,"9983320VKT");
	
	cout << "Items in Inventory:" << endl;
	for (i=0; i < 3; i++)
	{
		cout << "Item # " << i << endl;
		switch (objects[i].type) {
			case 'f':
				cout << "Item type is Furniture." << endl;
				cout << "Item name : " << objects[i].name << endl;
				cout << "     room : " 
				     << objects[i].item.furniture.room << endl;
				cout << "    price : "
				     << objects[i].item.furniture.price << endl;
				
				break;
			case 'c':
				cout << "Item type is Clothes." << endl;
				cout << "Item name : " << objects[i].name << endl;
				cout << "   person : " 
				     << objects[i].item.clothes.person << endl;
				cout << "   closet : "
				     << objects[i].item.clothes.closet << endl;
				break;
			case 'e':
				cout << "Item type is Equipment." << endl;
				cout << "Item name : " << objects[i].name << endl;
				cout << "    brand : " 
				     << objects[i].item.equipment.brand << endl;
				cout << "  purpose : "
				     << objects[i].item.equipment.purpose << endl;
				cout << " serialno : "
				     << objects[i].item.equipment.serialno << endl;
				break;
			default:
				cout << "Unknown object type!" << endl;
				exit(0);
		}
	}			
}
