// family.cpp
#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <string.h>

class family_member {
		int age;
		char name[80];
	public:
		family_member();
		family_member(int inage, char *inname);
		~family_member();
		friend istream &operator >> (istream &stream, family_member &inobj);
		friend ostream &operator << (ostream &stream, family_member &inobj);
};

family_member::family_member()
{
	cout << "Calling no-arg family_member constructor." << endl;
	age = 0;
}

family_member::family_member(int inage, char *inname)
{
	cout << "Calling arg family_member constructor." << endl;
	age = inage;
	strcpy(name,inname);
}

family_member::~family_member()
{
	cout << "Calling family_member destructor." << endl;
}

istream &operator >> (istream &stream, family_member &inobj)
{
	cout << "Enter Name: ";
	stream >> inobj.name;
	cout << "Enter Age: ";
	stream >> inobj.age;
	return stream;
}

ostream &operator << (ostream &stream, family_member &inobj)
{
	stream << "Name: " << inobj.name << endl;
	stream << "Age : " << inobj.age << endl;
	return stream;
}

void main()
{
	int num_members=0, i=0;
	family_member *myfamily;
	
	cout << "Number of members in your family? ";
	cin >> num_members;
	
	myfamily = new family_member[num_members];
	if (!myfamily)
	{
		cout << "Memory Allocation Error!" << endl;
		exit(0);
	}
	
	cout << "Enter your family:" << endl;
	for (i=0; i < num_members; i++)
		cin >> myfamily[i];
	
	cout << "Here is your family:" << endl;
	for (i=0; i < num_members; i++)
		cout << myfamily[i];
	
	delete [] myfamily;
}
